unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ComCtrls, StdCtrls, ExtCtrls, ActnList;

type

  HANDLE = THandle;
  PWINUSB_INTERFACE_HANDLE = ^THandle;
  WINUSB_INTERFACE_HANDLE = Handle;
  GUID = THandle;

  TMainForm = class(TForm)
    StatusBar1: TStatusBar;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    Exit1: TMenuItem;
    Button1: TButton;
    Button3: TButton;
    ActionList1: TActionList;
    Action_AppClose: TAction;
    Action_UsbClose: TAction;
    Button2: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);


  private
    { Private 錾 }

  public
    { Public 錾 }


  end;



var
    MainForm: TMainForm;

    SUP64_Usb_Open      : function(  guidDeviceInterface:TGUID; phWinUSBHandle:PWINUSB_INTERFACE_HANDLE ):  BOOL; stdcall;
    SUP64_Usb_Close     : function( hWinUSBHandle:WINUSB_INTERFACE_HANDLE ): BOOL; stdcall;

    SUP64_Reg_Write     : function( hWinUSBHandle:WINUSB_INTERFACE_HANDLE; adrs:DWORD; range:DWORD; wd:UINT64 ): BOOL; stdcall;
    SUP64_Reg_Read      : function(  hWinUSBHandle:WINUSB_INTERFACE_HANDLE; adrs:DWORD; range:DWORD; rd:PUINT64 ): BOOL; stdcall;

implementation




{$R *.DFM}


//  ----------------------------------------------------------------
//  test
//  ----------------------------------------------------------------
procedure TMainForm.Button1Click(Sender: TObject);
const

    SUP64_RANGE_8BIT      =   $00;
    SUP64_RANGE_16BIT     =   $40;
    SUP64_RANGE_32BIT     =   $80;
    SUP64_RANGE_64BIT     =   $C0;

var

    hDLL                :   HMODULE;
    sts                 :   Boolean;
    guidDeviceInterface :   TGUID;
    hOpenID             :   WINUSB_INTERFACE_HANDLE;
    WriteData           :   UINT64;
    ReadData            :   UINT64;


begin


    //  DLL۰
    hDLL := LoadLibrary('SUP64.dll');



    guidDeviceInterface := StringToGUID('{82EFB874-53F7-4595-9B80-5388380A1B3A}');

    //  ۰ސ?
    if( hDLL <> 0 ) then
    begin

        //  ۰ސ
        Memo1.Lines.Append('LoadLibrary!!');

        //  ֐̱ڽ擾
        SUP64_Usb_Open := GetProcAddress( hDLL, PChar('_SUP64_Usb_Open@20'));
        SUP64_Usb_Close := GetProcAddress( hDLL, PChar('_SUP64_Usb_Close@4'));
        SUP64_Reg_Write := GetProcAddress( hDLL, PChar('_SUP64_Reg_Write@20'));
        SUP64_Reg_Read := GetProcAddress( hDLL, PChar('_SUP64_Reg_Read@16'));

        sts := SUP64_Usb_Open( guidDeviceInterface, @hOpenID );
        if( sts ) then begin

            Memo1.Lines.Append('Device OPEN!!');

            //  ڼ޽28ޯĒC3hײ
            WriteData := $C3;
            sts := SUP64_Reg_Write( hOpenID, 2, SUP64_RANGE_8BIT, WriteData );

            if( sts )   then begin
                Memo1.Lines.Append('ڼ޽ײĐ!!');
            end
            else
            begin
                Memo1.Lines.Append('ڼ޽ײĎs!!');
            end;


            //  ڼ޽2̓eذޯ
            sts := SUP64_Reg_Read( hOpenID, 2, SUP64_RANGE_8BIT, @ReadData );
            if( sts  )   then begin
                Memo1.Lines.Append('ڼ޽ذސ!!');
                Memo1.Lines.Append( IntToHex( ReadData, 2 ) + 'h');
            end
            else
            begin
                Memo1.Lines.Append('ڼ޽ذގs!!');
            end;

           SUP64_Usb_Close( hOpenID );

        end;

        //  DLL
        //  sv?FreeLibrarysƗOװ
        FreeLibrary( hDLL );

    end;
    Memo1.Lines.Append('I');


end;

procedure TMainForm.Button2Click(Sender: TObject);
begin

        ShowMessage('test');

end;

end.
